From: "Sam James" <sam@gentoo.org>
To: gentoo-commits@lists.gentoo.org
Subject: [gentoo-commits] repo/gentoo:master commit in: app-arch/xz-utils/
Date: Sat, 15 Jun 2024 22:46:05 +0000 (UTC) [thread overview]
Message-ID: <1718491526.25171b1f5847b461145906ac2bc230c462f62c21.sam@gentoo> (raw)
commit: 25171b1f5847b461145906ac2bc230c462f62c21
Author: Sam James <sam <AT> gentoo <DOT> org>
AuthorDate: Sat Jun 15 22:41:30 2024 +0000
Commit: Sam James <sam <AT> gentoo <DOT> org>
CommitDate: Sat Jun 15 22:45:26 2024 +0000
URL: https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=25171b1f
app-arch/xz-utils: workaround libtool bug preventing shared library build
* Fix detection of `file` with libtool-2.5.0 (which xz-5.4.7, xz.5.6.2
had dist tarballs created with). This only affects some targets. See
bug #934370.
See https://git.savannah.gnu.org/cgit/libtool.git/commit/?h=development&id=9a4a02615c9e7cbcfd690ed31874822a7d6aaea2.
* Add a sanity check for targets which support shared libraries where
we verify liblzma.so is in the image.
Use tc-is-static-only to handle the concern from bug #450436.
Bug: https://bugs.gentoo.org/450436
Closes: https://bugs.gentoo.org/934370
Signed-off-by: Sam James <sam <AT> gentoo.org>
...-utils-9999.ebuild => xz-utils-5.4.7-r1.ebuild} | 67 ++++++----------------
...-utils-9999.ebuild => xz-utils-5.6.2-r1.ebuild} | 15 +++++
app-arch/xz-utils/xz-utils-9999.ebuild | 15 +++++
3 files changed, 47 insertions(+), 50 deletions(-)
diff --git a/app-arch/xz-utils/xz-utils-9999.ebuild b/app-arch/xz-utils/xz-utils-5.4.7-r1.ebuild
similarity index 72%
copy from app-arch/xz-utils/xz-utils-9999.ebuild
copy to app-arch/xz-utils/xz-utils-5.4.7-r1.ebuild
index a5c27989d3cc..2b5beefd93f6 100644
--- a/app-arch/xz-utils/xz-utils-9999.ebuild
+++ b/app-arch/xz-utils/xz-utils-5.4.7-r1.ebuild
@@ -45,9 +45,9 @@ DESCRIPTION="Utils for managing LZMA compressed files"
HOMEPAGE="https://tukaani.org/xz/"
# See top-level COPYING file as it outlines the various pieces and their licenses.
-LICENSE="0BSD LGPL-2.1+ GPL-2+ doc? ( CC-BY-SA-4.0 )"
+LICENSE="public-domain LGPL-2.1+ GPL-2+"
SLOT="0"
-IUSE="cpu_flags_arm_crc32 doc +extra-filters pgo nls static-libs"
+IUSE="doc +extra-filters pgo nls static-libs"
if [[ ${PV} != 9999 ]] ; then
BDEPEND+=" verify-sig? ( >=sec-keys/openpgp-keys-lassecollin-20240529 )"
@@ -66,12 +66,15 @@ src_prepare() {
}
multilib_src_configure() {
+ # Workaround for bug #934370 (libtool-2.5.0), drop when dist tarball
+ # uses newer libtool with the fix.
+ export ac_cv_prog_ac_ct_FILECMD='file' FILECMD='file'
+
local myconf=(
--enable-threads
$(multilib_native_use_enable doc)
$(use_enable nls)
$(use_enable static-libs static)
- $(use_enable cpu_flags_arm_crc32 arm64-crc32)
)
if ! multilib_is_native_abi ; then
@@ -106,7 +109,6 @@ multilib_src_configure() {
multilib_src_compile() {
# -fprofile-partial-training because upstream note the test suite isn't super comprehensive
- # TODO: revisit that now we have the tar/xz loop below?
# See https://documentation.suse.com/sbp/all/html/SBP-GCC-10/index.html#sec-gcc10-pgo
local pgo_generate_flags=$(usev pgo "-fprofile-update=atomic -fprofile-dir=${T}/${ABI}-pgo -fprofile-generate=${T}/${ABI}-pgo $(test-flags-CC -fprofile-partial-training)")
local pgo_use_flags=$(usev pgo "-fprofile-use=${T}/${ABI}-pgo -fprofile-dir=${T}/${ABI}-pgo $(test-flags-CC -fprofile-partial-training)")
@@ -116,52 +118,6 @@ multilib_src_compile() {
if use pgo ; then
emake CFLAGS="${CFLAGS} ${pgo_generate_flags}" -k check
- local tar_pgo_args=()
-
- if has_version -b "app-alternatives/tar[gnu]" ; then
- tar_pgo_args+=(
- --mtime=@2718281828
- --sort=name
- )
- fi
-
- if multilib_is_native_abi ; then
- (
- shopt -s globstar
-
- tar \
- "${tar_pgo_args[@]}" \
- -cf xz-pgo-test-01.tar \
- {"${S}","${BUILD_DIR}"}/**/*.[cho] \
- {"${S}","${BUILD_DIR}"}/**/.libs/* \
- {"${S}","${BUILD_DIR}"}/**/**.txt \
- {"${S}","${BUILD_DIR}"}/tests/files
-
- stat --printf="xz-pgo-test-01.tar.tar size: %s\n" xz-pgo-test-01.tar || die
- md5sum xz-pgo-test-01.tar || die
- )
-
- local test_variants=(
- # Borrowed from ALT Linux
- # https://packages.altlinux.org/en/sisyphus/srpms/xz/specfiles/#line-80
- '-0 -C none'
- '-2 -C crc32'
- "$(usev extra-filters '-6 --arm --lzma2 -C crc64')"
- "$(usev extra-filters '-6 --x86 --lzma2=lc=4 -C sha256')"
- '-7e --format=lzma'
-
- # Our own variants
- ''
- '-9e'
- "$(usev extra-filters '--x86 --lzma2=preset=9e')"
- )
- local test_variant
- for test_variant in "${test_variants[@]}" ; do
- "${BUILD_DIR}"/src/xz/xz -c ${test_variant} xz-pgo-test-01.tar | "${BUILD_DIR}"/src/xz/xz -c -d - > /dev/null
- assert "Testing '${test_variant}' variant failed"
- done
- fi
-
if tc-is-clang; then
llvm-profdata merge "${T}"/${ABI}-pgo --output="${T}"/${ABI}-pgo/default.profdata || die
fi
@@ -171,6 +127,17 @@ multilib_src_compile() {
fi
}
+multilib_src_install() {
+ default
+
+ # bug #934370 and bug #450436
+ if ! tc-is-static-only && [[ ! -f "${ED}/usr/$(get_libdir)/liblzma.so" ]] ; then
+ eerror "Sanity check for liblzma.so failed."
+ eerror "Shared library wasn't built, possible libtool bug"
+ [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]] && die "liblzma.so not found in build, aborting"
+ fi
+}
+
multilib_src_install_all() {
find "${ED}" -type f -name '*.la' -delete || die
diff --git a/app-arch/xz-utils/xz-utils-9999.ebuild b/app-arch/xz-utils/xz-utils-5.6.2-r1.ebuild
similarity index 91%
copy from app-arch/xz-utils/xz-utils-9999.ebuild
copy to app-arch/xz-utils/xz-utils-5.6.2-r1.ebuild
index a5c27989d3cc..e63700af983e 100644
--- a/app-arch/xz-utils/xz-utils-9999.ebuild
+++ b/app-arch/xz-utils/xz-utils-5.6.2-r1.ebuild
@@ -66,6 +66,10 @@ src_prepare() {
}
multilib_src_configure() {
+ # Workaround for bug #934370 (libtool-2.5.0), drop when dist tarball
+ # uses newer libtool with the fix.
+ export ac_cv_prog_ac_ct_FILECMD='file' FILECMD='file'
+
local myconf=(
--enable-threads
$(multilib_native_use_enable doc)
@@ -171,6 +175,17 @@ multilib_src_compile() {
fi
}
+multilib_src_install() {
+ default
+
+ # bug #934370 and bug #450436
+ if ! tc-is-static-only && [[ ! -f "${ED}/usr/$(get_libdir)/liblzma.so" ]] ; then
+ eerror "Sanity check for liblzma.so failed."
+ eerror "Shared library wasn't built, possible libtool bug"
+ [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]] && die "liblzma.so not found in build, aborting"
+ fi
+}
+
multilib_src_install_all() {
find "${ED}" -type f -name '*.la' -delete || die
diff --git a/app-arch/xz-utils/xz-utils-9999.ebuild b/app-arch/xz-utils/xz-utils-9999.ebuild
index a5c27989d3cc..e63700af983e 100644
--- a/app-arch/xz-utils/xz-utils-9999.ebuild
+++ b/app-arch/xz-utils/xz-utils-9999.ebuild
@@ -66,6 +66,10 @@ src_prepare() {
}
multilib_src_configure() {
+ # Workaround for bug #934370 (libtool-2.5.0), drop when dist tarball
+ # uses newer libtool with the fix.
+ export ac_cv_prog_ac_ct_FILECMD='file' FILECMD='file'
+
local myconf=(
--enable-threads
$(multilib_native_use_enable doc)
@@ -171,6 +175,17 @@ multilib_src_compile() {
fi
}
+multilib_src_install() {
+ default
+
+ # bug #934370 and bug #450436
+ if ! tc-is-static-only && [[ ! -f "${ED}/usr/$(get_libdir)/liblzma.so" ]] ; then
+ eerror "Sanity check for liblzma.so failed."
+ eerror "Shared library wasn't built, possible libtool bug"
+ [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]] && die "liblzma.so not found in build, aborting"
+ fi
+}
+
multilib_src_install_all() {
find "${ED}" -type f -name '*.la' -delete || die
next reply other threads:[~2024-06-15 22:46 UTC|newest]
Thread overview: 251+ messages / expand[flat|nested] mbox.gz Atom feed top
2024-06-15 22:46 Sam James [this message]
-- strict thread matches above, loose matches on Subject: below --
2025-02-09 4:56 [gentoo-commits] repo/gentoo:master commit in: app-arch/xz-utils/ Sam James
2025-01-24 15:33 Matt Turner
2025-01-24 12:24 Sam James
2025-01-24 12:24 Sam James
2024-11-13 11:10 Arthur Zamarin
2024-11-11 14:47 Sam James
2024-10-30 15:14 Sam James
2024-10-05 10:23 Sam James
2024-10-02 2:11 Sam James
2024-07-23 5:02 Sam James
2024-07-23 5:02 Sam James
2024-07-23 5:02 Sam James
2024-07-23 5:02 Sam James
2024-07-23 5:02 Sam James
2024-07-23 5:02 Sam James
2024-07-23 5:02 Sam James
2024-07-23 4:17 Sam James
2024-07-17 5:05 Sam James
2024-07-17 4:56 Sam James
2024-07-17 4:56 Sam James
2024-07-17 4:55 Sam James
2024-07-17 4:44 Sam James
2024-07-17 4:44 Sam James
2024-07-17 4:44 Sam James
2024-06-24 0:32 Sam James
2024-06-21 22:55 Sam James
2024-06-18 15:49 Fabian Groffen
2024-06-16 9:39 Sam James
2024-06-16 9:16 Sam James
2024-06-16 9:16 Sam James
2024-06-16 9:16 Sam James
2024-06-02 3:43 Sam James
2024-05-31 21:58 Sam James
2024-05-31 21:48 Sam James
2024-05-31 14:30 Sam James
2024-05-31 14:28 Sam James
2024-05-31 14:28 Sam James
2024-05-29 18:37 Sam James
2024-05-29 17:31 Sam James
2024-05-29 17:31 Sam James
2024-04-16 1:24 Sam James
2024-04-15 23:13 Sam James
2024-04-03 6:36 Sam James
2024-03-30 21:52 Sam James
2024-03-30 21:48 Sam James
2024-03-30 19:42 Sam James
2024-03-28 4:21 Sam James
2024-03-24 12:12 Sam James
2024-03-24 11:39 Sam James
2024-03-24 11:37 Sam James
2024-03-24 11:34 Sam James
2024-03-19 3:42 Ionen Wolkens
2024-03-09 21:05 Sam James
2024-03-04 10:05 Sam James
2024-03-03 2:27 Sam James
2024-03-02 22:07 Sam James
2024-02-29 22:17 Sam James
2024-02-24 19:46 Arthur Zamarin
2024-02-24 14:04 Sam James
2024-02-24 10:36 Michał Górny
2024-02-24 10:22 Michał Górny
2024-02-24 10:13 Sam James
2024-02-24 10:13 Sam James
2024-02-14 18:34 Sam James
2024-02-06 22:42 Sam James
2024-01-26 12:29 Sam James
2024-01-26 12:29 Sam James
2024-01-26 12:23 Sam James
2023-12-28 4:04 Sam James
2023-11-16 16:22 Sam James
2023-11-12 16:50 Arthur Zamarin
2023-11-12 8:32 Arthur Zamarin
2023-11-12 8:32 Arthur Zamarin
2023-11-12 8:32 Arthur Zamarin
2023-11-12 8:20 Arthur Zamarin
2023-11-01 15:37 Sam James
2023-11-01 15:37 Sam James
2023-10-12 12:13 Sam James
2023-10-12 12:05 Sam James
2023-09-15 6:58 Sam James
2023-08-02 19:34 Arthur Zamarin
2023-08-02 13:14 Sam James
2023-06-17 15:13 Sam James
2023-06-17 12:05 Arthur Zamarin
2023-06-17 10:42 Arthur Zamarin
2023-06-17 9:03 Arthur Zamarin
2023-05-05 3:51 Michał Górny
2023-05-05 3:08 Sam James
2023-05-05 3:08 Sam James
2023-05-05 3:08 Sam James
2023-05-05 3:08 Sam James
2023-04-29 20:31 Sam James
2023-04-29 20:31 Sam James
2023-04-29 20:25 Sam James
2023-04-29 20:20 Sam James
2023-04-29 18:16 Arthur Zamarin
2023-04-29 18:08 Arthur Zamarin
2023-04-29 16:11 Arthur Zamarin
2023-04-29 15:23 Arthur Zamarin
2023-04-29 8:48 Sam James
2023-04-23 22:30 Sam James
2023-04-23 21:21 Sam James
2023-04-23 20:32 Sam James
2023-04-23 20:22 Sam James
2023-04-23 20:22 Sam James
2023-04-23 20:10 Sam James
2023-04-23 20:00 Sam James
2023-03-18 19:45 Sam James
2023-03-18 19:19 Sam James
2023-03-18 19:19 Sam James
2023-02-24 18:36 Sam James
2023-02-13 5:47 Sam James
2023-01-15 13:37 Sam James
2023-01-14 10:00 Arthur Zamarin
2023-01-13 20:18 Sam James
2023-01-13 19:57 Sam James
2023-01-13 19:56 Sam James
2023-01-13 19:56 Sam James
2023-01-13 19:56 Sam James
2023-01-13 19:56 Sam James
2023-01-13 19:56 Sam James
2023-01-11 23:02 Sam James
2023-01-11 22:08 Sam James
2023-01-11 22:08 Sam James
2023-01-11 22:08 Sam James
2022-12-16 7:22 Sam James
2022-12-14 5:19 Sam James
2022-12-14 5:19 Sam James
2022-12-14 5:19 Sam James
2022-12-14 5:19 Sam James
2022-12-14 5:19 Sam James
2022-12-14 5:19 Sam James
2022-12-14 3:52 Sam James
2022-12-14 3:52 Sam James
2022-12-13 20:15 Sam James
2022-12-13 20:15 Sam James
2022-12-13 20:15 Sam James
2022-12-11 17:51 Arthur Zamarin
2022-12-10 3:16 Sam James
2022-12-10 2:55 Sam James
2022-12-10 2:54 Sam James
2022-12-10 2:54 Sam James
2022-12-10 2:53 Sam James
2022-12-10 2:53 Sam James
2022-12-10 2:53 Sam James
2022-11-30 23:26 Sam James
2022-11-30 23:26 Sam James
2022-11-25 15:20 Arthur Zamarin
2022-11-25 10:34 Arthur Zamarin
2022-11-25 9:32 Arthur Zamarin
2022-11-25 8:59 Arthur Zamarin
2022-11-25 8:19 Sam James
2022-11-25 8:19 Sam James
2022-11-25 8:11 Arthur Zamarin
2022-11-25 8:11 Arthur Zamarin
2022-11-15 9:45 Sam James
2022-11-13 20:59 Sam James
2022-10-28 7:02 Sam James
2022-10-28 7:02 Sam James
2022-10-28 6:39 Arthur Zamarin
2022-10-28 6:39 Arthur Zamarin
2022-10-28 6:39 Arthur Zamarin
2022-10-28 6:39 Arthur Zamarin
2022-10-28 6:39 Arthur Zamarin
2022-10-28 5:19 Arthur Zamarin
2022-10-27 23:46 Sam James
2022-09-30 19:13 Sam James
2022-09-26 4:16 Arthur Zamarin
2022-09-23 6:39 Arthur Zamarin
2022-09-23 6:09 Arthur Zamarin
2022-09-23 5:50 Sam James
2022-09-23 5:50 Sam James
2022-09-23 5:46 Sam James
2022-09-23 5:41 Arthur Zamarin
2022-09-23 5:41 Arthur Zamarin
2022-08-22 22:37 Sam James
2022-08-12 17:32 Sam James
2022-04-10 17:38 Arthur Zamarin
2022-04-10 17:38 Arthur Zamarin
2022-04-10 17:38 Arthur Zamarin
2022-04-09 20:04 Arthur Zamarin
2022-04-09 19:50 Arthur Zamarin
2022-04-09 18:21 Arthur Zamarin
2022-04-09 17:57 Agostino Sarubbo
2022-04-08 7:06 Agostino Sarubbo
2022-04-06 23:58 Sam James
2022-04-06 23:34 Sam James
2022-04-06 23:34 Sam James
2021-07-16 22:11 David Seifert
2021-01-06 12:52 Fabian Groffen
2020-12-27 13:34 Fabian Groffen
2020-09-18 10:30 Lars Wendler
2020-09-11 12:45 Mikle Kolyada
2020-08-30 5:27 Sam James
2020-08-29 14:48 Thomas Deutschmann
2020-08-28 16:53 Sergei Trofimovich
2020-08-27 18:22 Sergei Trofimovich
2020-08-22 5:43 Agostino Sarubbo
2020-08-21 18:20 Agostino Sarubbo
2020-05-07 18:56 Fabian Groffen
2020-03-19 22:10 Thomas Deutschmann
2020-03-18 7:59 Lars Wendler
2020-03-12 8:55 Lars Wendler
2019-06-12 8:35 Michael Haubenwallner
2019-05-13 15:20 Michael Haubenwallner
2019-05-13 8:08 Lars Wendler
2019-05-04 11:02 Mikle Kolyada
2019-05-03 23:17 Andreas K. Hüttel
2019-04-09 19:07 Aaron Bauman
2019-04-06 13:39 Mikle Kolyada
2019-04-01 19:58 Thomas Deutschmann
2019-03-26 20:05 Markus Meier
2019-03-25 11:40 Mikle Kolyada
2019-03-25 11:40 Mikle Kolyada
2019-03-25 11:39 Mikle Kolyada
2019-03-24 20:25 Sergei Trofimovich
2019-03-24 20:12 Sergei Trofimovich
2019-03-24 19:44 Sergei Trofimovich
2019-03-24 13:08 Sergei Trofimovich
2019-03-20 21:09 Mikle Kolyada
2019-03-20 19:37 Sergei Trofimovich
2019-03-03 19:27 Lars Wendler
2018-05-12 21:56 Lars Wendler
2018-04-30 11:36 Thomas Deutschmann
2018-04-30 11:36 Thomas Deutschmann
2018-04-30 11:36 Thomas Deutschmann
2018-04-30 11:31 Lars Wendler
2018-04-30 2:58 Lars Wendler
2018-04-30 2:58 Lars Wendler
2018-01-26 18:55 Mike Gilbert
2017-12-25 14:43 David Seifert
2017-12-17 21:08 Thomas Deutschmann
2017-12-17 21:08 Thomas Deutschmann
2017-12-17 21:08 Thomas Deutschmann
2017-02-05 19:32 Markus Meier
2017-01-29 20:43 Jeroen Roovers
2017-01-23 18:27 Tobias Klausmann
2017-01-23 15:46 Agostino Sarubbo
2017-01-23 13:51 Agostino Sarubbo
2016-12-30 19:05 Lars Wendler
2016-12-30 19:05 Lars Wendler
2016-03-30 23:48 Mike Frysinger
2016-03-30 23:48 Mike Frysinger
2016-02-29 8:46 Stephen Klimaszewski
2016-02-13 15:33 Agostino Sarubbo
2016-02-04 11:34 Tobias Klausmann
2016-02-01 16:26 Jeroen Roovers
2016-01-28 19:24 Richard Farina
2015-09-29 13:38 Mike Frysinger
2015-09-29 13:38 Mike Frysinger
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=1718491526.25171b1f5847b461145906ac2bc230c462f62c21.sam@gentoo \
--to=sam@gentoo.org \
--cc=gentoo-commits@lists.gentoo.org \
--cc=gentoo-dev@lists.gentoo.org \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox